 import java.util.*;
 
public class Adulte extends Personne {
	String profession;
	private Adulte conjoint;
	ArrayList enfants;
	
 	Adulte(Enfant e, String profession)
 	{super(e.sexe,e.date_naissance,e.prenom);
	 if (e.date_deces!=null)  problemeCreation("L'enfant est dja dcd",e);
	 nom=e.nom;
	 pere=e.pere;
	 mere=e.mere;
	 this.profession=profession;
	 this.conjoint=null;
	 enfants = new ArrayList();
	 population.remove(e);
	 if (pere!=null) {pere.enfants.remove(e);pere.enfants.add(this);}
	 if (mere!=null) {mere.enfants.remove(e);mere.enfants.add(this);}
	 }
	 
	 public String toString() {
	 String resultat=super.toString()+" - profession "+profession;
	 if (conjoint!=null) resultat=resultat+" mari(e)  "+conjoint.getPrenom()+" "+conjoint.getNom();
	 return resultat;
	 }
 	
	public boolean veuf()
	{return (conjoint!=null && conjoint.date_deces!=null);}
	
	public void mariage(Adulte epoux) {
		if (sexe==epoux.sexe) throw new RuntimeException("Le mariage entre personnes du mme sexe n'est pas (encore)autoris.");
		else if ((date_deces!=null) || (epoux.date_deces!=null)) throw new RuntimeException("Un mort de peut pas se marier.");
		else if ((conjoint!=null && !veuf()) || (epoux.conjoint!=null && !epoux.veuf()))  throw new RuntimeException("La polygamie est interdite.");
		else {conjoint=epoux;
			epoux.conjoint=this;}
		}
	
	public void arbreGenealogiqueDescendants(int indentation){
		for (int i=0;i<indentation-1;i++) System.out.print("  ");
		System.out.println(toString());
		for (int i=0;i<enfants.size();i++)
			{Object e=enfants.get(i);
			  if (e instanceof Adulte) ((Adulte)e).arbreGenealogiqueDescendants(indentation+1);
			  else {for (int j=0;j<indentation;j++) System.out.print("  ");
			  	   System.out.println(e+e.getClass().toString());}
			}	   
	}

 	public static void main(String args[]) {
	Personne p=new Bebe(true,new Date(80,2,1),"Adam","Dupont");
	p=new Enfant((Bebe)p,"CM1","Ecole de la Fort");
	p=new Adulte((Enfant)p,"Cueilleur de pommes");
	Personne e=new Bebe(false,new Date(80,2,1),"Eve","Durand");
	e=new Enfant((Bebe)e,"CM2","Ecole de la Fort");
	e=new Adulte((Enfant)e,"Charmeuses de serpents");
	((Adulte)p).mariage((Adulte)e);
	System.out.println(p);
	System.out.println(e);
	}
	
}